"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const t = require("@babel/types");
const getConcatedComments_1 = require("../helpers/getConcatedComments");
const processFunctionProperty_1 = require("../helpers/processFunctionProperty");
function default_1(nodeOfVueOptions) {
    const node = nodeOfVueOptions.get('computed');
    if (node && t.isObjectExpression(node.value)) {
        const properties = node.value.properties;
        return properties.map(p => {
            if (t.isSpreadElement(p)) {
                return null;
            }
            else if (processFunctionProperty_1.isFunctionProperty(p)) {
                return {
                    name: p.key.name,
                    comment: getConcatedComments_1.default(p.leadingComments || []),
                    func: processFunctionProperty_1.default(p)
                };
            }
            else if (t.isObjectProperty(p)) {
                const baseInfo = {
                    name: p.key.name,
                    comment: getConcatedComments_1.default(p.leadingComments || [])
                };
                const value = p.value;
                if (t.isObjectExpression(value)) {
                    const comProperties = value.properties;
                    const mapedFunctionDesc = comProperties
                        .filter((v) => !t.isSpreadElement(v))
                        .map(v => processFunctionProperty_1.default(v));
                    const getter = mapedFunctionDesc.find(v => v.name === 'get');
                    const setter = mapedFunctionDesc.find(v => v.name === 'set');
                    if (getter) {
                        baseInfo.getter = getter;
                    }
                    if (setter) {
                        baseInfo.setter = setter;
                    }
                }
                return baseInfo;
            }
            return null;
        }).filter((v) => !!v);
    }
    return [];
}
exports.default = default_1;
//# sourceMappingURL=computedReader.js.map