"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const t = require("@babel/types");
const generator_1 = require("@babel/generator");
const getConcatedComments_1 = require("../helpers/getConcatedComments");
function default_1(nodeOfVueOptions) {
    const node = nodeOfVueOptions.get('data');
    if (node && t.isBlockStatement(node.body)) {
        const returnData = node.body.body.find((n) => t.isReturnStatement(n));
        if (returnData && returnData.argument && t.isObjectExpression(returnData.argument)) {
            const properties = returnData.argument.properties;
            return properties.map(dataNode => {
                if (t.isObjectProperty(dataNode)) {
                    const data = {
                        name: dataNode.key.name,
                        value: generator_1.default(dataNode.value).code,
                        comment: getConcatedComments_1.default(dataNode.leadingComments || [])
                    };
                    return data;
                }
                else if (t.isObjectMethod(dataNode)) {
                    const data = {
                        name: dataNode.key.name,
                        value: generator_1.default(dataNode).code,
                        comment: getConcatedComments_1.default(dataNode.leadingComments || [])
                    };
                    return data;
                }
                else {
                    return null;
                }
            }).filter((v) => !!v);
        }
        else {
            console.warn('no return found in data');
            return [];
        }
    }
    return [];
}
exports.default = default_1;
//# sourceMappingURL=dataReader.js.map