"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const ComponentTypes_1 = require("../ComponentTypes");
const getConcatedComments_1 = require("../helpers/getConcatedComments");
const processFunctionProperty_1 = require("../helpers/processFunctionProperty");
function default_1(nodeOfVueOptions) {
    return ComponentTypes_1.lifeCycleName
        .reduce((sofar, name) => {
        const node = nodeOfVueOptions.get(name);
        if (node) {
            return [...sofar, node];
        }
        return sofar;
    }, [])
        .map(lcNode => {
        if (processFunctionProperty_1.isFunctionProperty(lcNode)) {
            return {
                comment: getConcatedComments_1.default(lcNode.leadingComments || []),
                ...processFunctionProperty_1.default(lcNode)
            };
        }
        return null;
    })
        .filter((v) => !!v);
}
exports.default = default_1;
//# sourceMappingURL=lifeCyclesReader.js.map