"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const t = require("@babel/types");
const getConcatedComments_1 = require("../helpers/getConcatedComments");
const processFunctionProperty_1 = require("../helpers/processFunctionProperty");
function default_1(nodeOfVueOptions) {
    const node = nodeOfVueOptions.get('methods');
    if (node && t.isObjectExpression(node.value)) {
        const properties = node.value.properties;
        return properties.map(p => {
            return t.isSpreadElement(p) ? null : {
                comment: getConcatedComments_1.default(p.leadingComments || []),
                ...processFunctionProperty_1.default(p)
            };
        }).filter((v) => !!v);
    }
    return [];
}
exports.default = default_1;
//# sourceMappingURL=methodsReader.js.map