"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const t = require("@babel/types");
const getConcatedComments_1 = require("../helpers/getConcatedComments");
const processFunctionProperty_1 = require("../helpers/processFunctionProperty");
function default_1(nodeOfVueOptions) {
    const node = nodeOfVueOptions.get('watch');
    if (node && t.isObjectExpression(node.value)) {
        const properties = node.value.properties;
        return properties.map(p => {
            if (t.isSpreadElement(p)) {
                return null;
            }
            else if (processFunctionProperty_1.isFunctionProperty(p)) {
                const resWatch = {
                    name: p.key.name,
                    comment: getConcatedComments_1.default(p.leadingComments || []),
                    handler: processFunctionProperty_1.default(p)
                };
                return resWatch;
            }
            else if (t.isObjectProperty(p)) {
                const value = p.value;
                if (t.isObjectExpression(value)) {
                    const watchProperties = value.properties;
                    const handlerNode = watchProperties.find(v => !t.isSpreadElement(v) && v.key.name === 'handler');
                    if (!handlerNode) {
                        return null;
                    }
                    const immediateNode = watchProperties.find(v => !t.isSpreadElement(v) && v.key.name === 'immediate');
                    const deepNode = watchProperties.find(v => !t.isSpreadElement(v) && v.key.name === 'deep');
                    const handler = processFunctionProperty_1.default(handlerNode);
                    const immediate = immediateNode ? immediateNode.value.value : undefined;
                    const deep = deepNode ? deepNode.value.value : undefined;
                    const resWatch = {
                        name: p.key.name,
                        comment: getConcatedComments_1.default(p.leadingComments || []),
                        handler
                    };
                    if (deep !== undefined) {
                        resWatch.deep = deep;
                    }
                    if (immediate !== undefined) {
                        resWatch.immediate = immediate;
                    }
                    return resWatch;
                }
            }
            return null;
        }).filter((v) => !!v);
    }
    return [];
}
exports.default = default_1;
//# sourceMappingURL=watchReader.js.map