"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const vue_template_compiler_1 = require("vue-template-compiler");
const parser_1 = require("@babel/parser");
function defaultParse(script) {
    return parser_1.parse(script, {
        sourceType: 'module',
        plugins: [
            'dynamicImport',
            'jsx'
        ]
    });
}
exports.defaultParse = defaultParse;
function scriptToAST(code) {
    const sfc = vue_template_compiler_1.parseComponent(code);
    const ast = defaultParse(sfc.script ? sfc.script.content : '');
    return ast;
}
exports.default = scriptToAST;
//# sourceMappingURL=scriptToAST.js.map